<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
   
   <meta name="description" content="FLUBIO - An unstructured, parallel, finite volume Navier-Stokes solver for teaching and research purposes">
    
    <meta name="author" content="Edoardo Alinovi and Joel Guerrero" >
    <link rel="icon" href="../favicon.png">

    <title>compact &ndash; FLUBIO</title>

    <link href="../css/bootstrap.min.css" rel="stylesheet">
    <link href="../css/pygments.css" rel="stylesheet">
    <link href="../css/font-awesome.min.css" rel="stylesheet">
    <link href="../css/local.css" rel="stylesheet">
    
    <link  href="../tipuesearch/tipuesearch.css" rel="stylesheet">
    
    

    <!-- HTML5 shim and Respond.js for IE8 support of HTML5 elements and media queries -->
    <!--[if lt IE 9]>
      <script src="https://oss.maxcdn.com/html5shiv/3.7.2/html5shiv.min.js"></script>
      <script src="https://oss.maxcdn.com/respond/1.4.2/respond.min.js"></script>
    <![endif]-->
    
    <script src="../js/jquery-2.1.3.min.js"></script>
    <script src="../js/svg-pan-zoom.min.js"></script>

  </head>

  <body>

    <!-- Fixed navbar -->
    <nav class="navbar navbar-inverse navbar-fixed-top">
      <div class="container">
        <div class="navbar-header">
          <button type="button" class="navbar-toggle collapsed" data-toggle="collapse" data-target="#navbar" aria-expanded="false" aria-controls="navbar">
            <span class="sr-only">Toggle navigation</span>
            <span class="icon-bar"></span>
            <span class="icon-bar"></span>
            <span class="icon-bar"></span>
          </button>
          <a class="navbar-brand" href="../index.html">FLUBIO </a>
        </div>
        <div id="navbar" class="navbar-collapse collapse">
          <ul class="nav navbar-nav">
        
            <li class="dropdown hidden-xs visible-sm visible-md hidden-lg">
              <a href="#" class="dropdown-toggle"
              data-toggle="dropdown" role="button"
              aria-haspopup="true"
     aria-expanded="false">Contents <span class="caret"></span></a>
        <ul class="dropdown-menu">
          
              
            <li><a href="../lists/files.html">Source Files</a></li>
        
        
        
            <li><a href="../lists/modules.html">Modules</a></li>
        
            
                                
            <li><a href="../lists/procedures.html">Procedures</a></li>
        
               
            <li><a href="../lists/types.html">Derived Types</a></li>
        
        
            <li><a href="../lists/programs.html">Programs</a></li>
               
        
        
            </ul>
        
            </li>


<li class="visible-xs hidden-sm visible-lg"><a href="../lists/files.html">Source Files</a></li>



<li class="visible-xs hidden-sm visible-lg"><a href="../lists/modules.html">Modules</a></li>



<li class="visible-xs hidden-sm visible-lg"><a href="../lists/procedures.html">Procedures</a></li>

                             
<li class="visible-xs hidden-sm visible-lg"><a href="../lists/types.html">Derived Types</a></li>


<li class="visible-xs hidden-sm visible-lg"><a href="../lists/programs.html">Programs</a></li>



          </ul>
        
        <form action="../search.html" class="navbar-form navbar-right" role="search">
        <div class="form-group">
          <input type="text" class="form-control" placeholder="Search" name="q" id="tipue_search_input" autocomplete="off" required>
        </div>
<!--
        <button type="submit" class="btn btn-default">Submit</button>
-->
        </form>
        
        </div><!--/.nav-collapse -->
      </div>
    </nav>

    <div class="container">
    
  
  <div class="row">
    <h1>compact
      <small>Function</small>
    
    </h1>
    
<div class="row">
  <div class="col-lg-12">
<div class="well well-sm">
  <ul class="list-inline" style="margin-bottom:0px;display:inline">
     
     
     
    <li><i class="fa fa-legal"></i> <a rel="license" href="http://creativecommons.org/licenses/by-nc/4.0/"><img alt="Creative Commons License" style="border-width:0" src="https://i.creativecommons.org/l/by-nc/4.0/80x15.png" /></a></li> 
     
     
     
    
    
     <li><i class="fa fa-list-ol"></i>
       <a data-toggle="tooltip"
    data-placement="bottom" data-html="true"
    title=" 0.2% of total for procedures.">45 statements</a>
     </li> 
     
     
     
    <li><i class="fa fa-code"></i><a href="../src/mstrings.f03"> Source File</a></li>
     
     
  </ul>
  <ol class="breadcrumb in-well text-right">
  
    
     <li><a href='../sourcefile/mstrings.f03.html'>mstrings.f03</a></li>
    
     <li><a href='../module/m_strings.html'>M_strings</a></li>
    
  
     <li class="active">compact</li>
  </ol>
</div>
</div>
</div>
<script>
  $(function () {
  $('[data-toggle="tooltip"]').tooltip()
  })
</script>

  </div>
  
  <div class="row">
    <div class="col-md-3 hidden-xs hidden-sm visible-md visible-lg">
    
<div id="sidebar">
  
<h3>Contents</h3>
 





















<em>None</em>


</div>

    </div>
    
    <div class="col-md-9" id='text'>
    <h2>
public function compact(str, char) result(outstr)
    
    
   
</h2>
    
  


    
    <h2>NAME</h2>
<div class="codehilite"><pre><span></span><code>compact(3f) - [M_strings:WHITESPACE] converts contiguous whitespace to a single character (or nothing)
</code></pre></div>

<h2>SYNOPSIS</h2>
<div class="codehilite"><pre><span></span><code><span class="k">function</span><span class="w"> </span><span class="nf">compact(STR,CHAR) result </span><span class="p">(</span>OUTSTR<span class="p">)</span><span class="w"></span>

<span class="w"> </span><span class="n">character</span><span class="p">(</span><span class="n">len</span><span class="p">=</span><span class="o">*</span><span class="p">),</span><span class="n">intent</span><span class="p">(</span><span class="n">in</span><span class="p">)</span><span class="w">          </span><span class="p">::</span><span class="w"> </span><span class="n">STR</span><span class="w"></span>
<span class="w"> </span><span class="n">character</span><span class="p">(</span><span class="n">len</span><span class="p">=</span><span class="o">*</span><span class="p">),</span><span class="n">intent</span><span class="p">(</span><span class="n">in</span><span class="p">),</span><span class="n">optional</span><span class="w"> </span><span class="p">::</span><span class="w"> </span><span class="n">CHAR</span><span class="w"></span>
<span class="w"> </span><span class="n">character</span><span class="p">(</span><span class="n">len</span><span class="p">=</span><span class="n">len</span><span class="p">(</span><span class="n">str</span><span class="p">))</span><span class="w">              </span><span class="p">::</span><span class="w"> </span><span class="n">OUTSTR</span><span class="w"></span>
</code></pre></div>

<h2>DESCRIPTION</h2>
<div class="codehilite"><pre><span></span><code>COMPACT(3f) converts multiple spaces, tabs and control characters
(called &quot;whitespace&quot;) to a single character or nothing. Leading
whitespace is removed.
</code></pre></div>

<h2>OPTIONS</h2>
<div class="codehilite"><pre><span></span><code><span class="nv">STR</span>     <span class="nv">input</span> <span class="nv">string</span> <span class="nv">to</span> <span class="nv">reduce</span> <span class="nv">or</span> <span class="nv">remove</span> <span class="nv">whitespace</span> <span class="nv">from</span>
<span class="nv">CHAR</span>    <span class="nv">By</span> <span class="nv">default</span> <span class="nv">the</span> <span class="nv">character</span> <span class="nv">that</span> <span class="nv">replaces</span> <span class="nv">adjacent</span>
        <span class="nv">whitespace</span> <span class="nv">is</span> <span class="nv">a</span> <span class="nv">space</span>. <span class="k">If</span> <span class="nv">the</span> <span class="nv">optional</span> <span class="nv">CHAR</span> <span class="nv">parameter</span> <span class="nv">is</span> <span class="nv">supplied</span>
        <span class="nv">it</span> <span class="nv">will</span> <span class="nv">be</span> <span class="nv">used</span> <span class="nv">to</span> <span class="nv">replace</span> <span class="nv">the</span> <span class="nv">whitespace</span>. <span class="k">If</span> <span class="nv">a</span> <span class="nv">null</span> <span class="nv">character</span> <span class="nv">is</span>
        <span class="nv">supplied</span> <span class="k">for</span> <span class="nv">CHAR</span> <span class="nv">whitespace</span> <span class="nv">is</span> <span class="nv">removed</span>.
</code></pre></div>

<h2>RETURNS</h2>
<div class="codehilite"><pre><span></span><code>OUTSTR  string of same length as input string but with all contiguous whitespace
        reduced to a single space and leading whitespace removed
</code></pre></div>

<h2>EXAMPLES</h2>
<p>Sample Program:</p>
<div class="codehilite"><pre><span></span><code><span class="nv">program</span> <span class="nv">demo_compact</span>
 <span class="nv">use</span> <span class="nv">M_strings</span>, <span class="nv">only</span> : <span class="nv">compact</span>
 <span class="nv">implicit</span> <span class="nv">none</span>
 <span class="o">!</span> <span class="nv">produces</span> <span class="s1">&#39;</span><span class="s">This is a test               </span><span class="s1">&#39;</span>
 <span class="nv">write</span><span class="ss">(</span><span class="o">*</span>,<span class="o">*</span><span class="ss">)</span><span class="nv">compact</span><span class="ss">(</span><span class="s1">&#39;</span><span class="s">  This     is      a     test  </span><span class="s1">&#39;</span><span class="ss">)</span>
 <span class="o">!</span> <span class="nv">produces</span> <span class="s1">&#39;</span><span class="s">Thisisatest                  </span><span class="s1">&#39;</span>
 <span class="nv">write</span><span class="ss">(</span><span class="o">*</span>,<span class="o">*</span><span class="ss">)</span><span class="nv">compact</span><span class="ss">(</span><span class="s1">&#39;</span><span class="s">  This     is      a     test  </span><span class="s1">&#39;</span>,<span class="nv">char</span><span class="o">=</span><span class="s1">&#39;&#39;</span><span class="ss">)</span>
 <span class="o">!</span> <span class="nv">produces</span> <span class="s1">&#39;</span><span class="s">This:is:a:test               </span><span class="s1">&#39;</span>
 <span class="nv">write</span><span class="ss">(</span><span class="o">*</span>,<span class="o">*</span><span class="ss">)</span><span class="nv">compact</span><span class="ss">(</span><span class="s1">&#39;</span><span class="s">  This     is      a     test  </span><span class="s1">&#39;</span>,<span class="nv">char</span><span class="o">=</span><span class="s1">&#39;</span><span class="s">:</span><span class="s1">&#39;</span><span class="ss">)</span>
 <span class="o">!</span> <span class="nv">note</span> <span class="nv">CHAR</span> <span class="nv">is</span> <span class="nv">used</span> <span class="nv">to</span> <span class="nv">replace</span> <span class="nv">the</span> <span class="nv">whitespace</span>, <span class="nv">but</span> <span class="k">if</span> <span class="nv">CHAR</span> <span class="nv">is</span>
 <span class="o">!</span> <span class="nv">in</span> <span class="nv">the</span> <span class="nv">original</span> <span class="nv">string</span> <span class="nv">it</span> <span class="nv">is</span> <span class="nv">just</span> <span class="nv">copied</span>
 <span class="nv">write</span><span class="ss">(</span><span class="o">*</span>,<span class="o">*</span><span class="ss">)</span><span class="nv">compact</span><span class="ss">(</span><span class="s1">&#39;</span><span class="s">A  AA    A   AAAAA</span><span class="s1">&#39;</span>,<span class="nv">char</span><span class="o">=</span><span class="s1">&#39;</span><span class="s">A</span><span class="s1">&#39;</span><span class="ss">)</span>
 <span class="o">!</span> <span class="nv">produces</span> <span class="ss">(</span><span class="nv">original</span> <span class="nv">A</span> <span class="nv">characters</span> <span class="nv">are</span> <span class="nv">left</span> <span class="nv">as</span><span class="o">-</span><span class="nv">is</span><span class="ss">)</span> <span class="s1">&#39;</span><span class="s">AAAAAAAAAAAA</span><span class="s1">&#39;</span>
 <span class="o">!</span> <span class="nv">not</span> <span class="s1">&#39;</span><span class="s">A</span><span class="s1">&#39;</span>
<span class="k">end</span> <span class="nv">program</span> <span class="nv">demo_compact</span>

<span class="nv">Expected</span> <span class="nv">output</span>

 <span class="o">&gt;</span><span class="nv">This</span> <span class="nv">is</span> <span class="nv">a</span> <span class="nv">test</span>
 <span class="o">&gt;</span><span class="nv">Thisisatest</span>
 <span class="o">&gt;</span><span class="nv">This</span>:<span class="nv">is</span>:<span class="nv">a</span>:<span class="nv">test</span>
 <span class="o">&gt;</span><span class="nv">AAAAAAAAAAAA</span>
</code></pre></div>
    

    <h3>Arguments</h3>
    
      
<table class="table table-striped varlist">
<thead><tr><th>Type</th>
<th>Intent</th><th>Optional</th>
<th>Attributes</th><th></th><th>Name</th><th></th></thead>



<tbody>

  
  
  
  
<tr>
  
  <td><span class="anchor" id="variable-str%7E4"></span>character(len=*),</td>
  <td>intent(in)</td>
  <td></td>
  
  <td></td><td>::</td>
  <td><strong>str</strong></td><td></td>
  
</tr>

  
  
  
  
<tr>
  
  <td><span class="anchor" id="variable-char"></span>character(len=*),</td>
  <td>intent(in),</td>
  <td>optional</td>
  
  <td></td><td>::</td>
  <td><strong>char</strong></td><td></td>
  
</tr>

</tbody>
</table>

    
    
    
    
    
    
    
   <h3>Return Value <small><span class="anchor" id="variable-outstr%7E2"></span>character(len=len)
  </small></h3>
    
    
    
    
     
    <br>

    <section class="visible-xs visible-sm hidden-md">
      
<h3>Contents</h3>
 





















<em>None</em>


    </section>
    <br class="visible-xs visible-sm hidden-md">

    

    
    
    
    
    

    
    
    
    
    


    
    
    
    
    </div>
  </div>


    <hr>    
    </div> <!-- /container -->
    <footer>
      <div class="container">
      <div class="row">
        <div class="col-xs-6 col-md-6"><p>FLUBIO was developed by Edoardo Alinovi and Joel Guerrero<br>&copy; 2021 <a rel="license" href="http://creativecommons.org/licenses/by-nc/4.0/"><img alt="Creative Commons License" style="border-width:0" src="https://i.creativecommons.org/l/by-nc/4.0/80x15.png" /></a>
                                          </p>
        </div>
        <div class="col-xs-6 col-md-6">
          <p class="text-right">
            Documentation generated by 
            <a href="https://github.com/Fortran-FOSS-Programmers/ford">FORD</a>
            
            
          </p>
        </div>
      </div>
      <br>
      </div> <!-- /container -->    
    </footer>

    <!-- Bootstrap core JavaScript
    ================================================== -->
    <!-- Placed at the end of the document so the pages load faster -->
<!--
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/1.11.1/jquery.min.js"></script>
-->
    <script src="../js/bootstrap.min.js"></script>
    <!-- IE10 viewport hack for Surface/desktop Windows 8 bug -->
    <script src="../js/ie10-viewport-bug-workaround.js"></script>

    <!-- MathJax JavaScript
    ================================================== -->
    <!-- Placed at the end of the document so the pages load faster -->
    <script type="text/x-mathjax-config">
      MathJax.Hub.Config({
        TeX: { extensions: ['AMSmath.js','AMSsymbols.js','noErrors.js','noUndefined.js'], equationNumbers: { autoNumber: 'AMS' } },
        jax: ['input/TeX','input/MathML','output/HTML-CSS'],
        extensions: ['tex2jax.js','mml2jax.js','MathMenu.js','MathZoom.js']
      });
    </script>
    
    <script src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.1/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>
    
    
    <script src="../tipuesearch/tipuesearch_content.js"></script>
    <script src="../tipuesearch/tipuesearch_set.js"></script>
    <script src="../tipuesearch/tipuesearch.js"></script>
    
    
  </body>
</html>